# Class String

java.lang.Object
java.lang.String

All Implemented Interfaces:
  `CharSequence, Comparable<String>`

public final class String extends java.lang.Object implements CharSequence, Comparable<String>
The String class represents character strings. All string literals in Java programs, such as "abc", are implemented as instances of this class. Strings are constant; their values cannot be changed after they are created. String buffers support mutable strings. Because String objects are immutable they can be shared. For example: is equivalent to: Here are some more examples of how strings can be used: The class String includes methods for examining individual characters of the sequence, for comparing strings, for searching strings, for extracting substrings, and for creating a copy of a string with all characters translated to uppercase or to lowercase. The Java language provides special support for the string concatenation operator (+), and for conversion of other objects to strings. String concatenation is implemented through the StringBuffer class and its append method. String conversions are implemented through the method toString, defined by Object and inherited by all classes in Java. For additional information on string concatenation and conversion, see Gosling, Joy, and Steele, The Java Language Specification. Since: JDK1.0, CLDC 1.0 See Also:Object.toString(), StringBuffer, StringBuffer.append(boolean), StringBuffer.append(char), StringBuffer.append(char[]), StringBuffer.append(char[], int, int), StringBuffer.append(int), StringBuffer.append(long), StringBuffer.append(java.lang.Object), StringBuffer.append(java.lang.String)

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Comparator<String>`
  `CASE_INSENSITIVE_ORDER`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `String()`
  Initializes a newly created String object so that it represents an empty character sequence.
  `String(byte[] bytes)`
  Construct a new String by converting the specified array of bytes using the platform's default character encoding.
  `String(byte[] bytes, int off, int len)`
  Construct a new String by converting the specified subarray of bytes using the platform's default character encoding.
  `String(byte[] bytes, int off, int len, String enc)`
  Construct a new String by converting the specified subarray of bytes using the specified character encoding.
  `String(byte[] bytes, String enc)`
  Construct a new String by converting the specified array of bytes using the specified character encoding.
  `String(byte[] bytes, java.nio.charset.Charset charset)`
  Construct a new String by converting the specified array of bytes using the specified character encoding.
  `String(char[] value)`
  Allocates a new String so that it represents the sequence of characters currently contained in the character array argument.
  `String(char[] value, int offset, int count)`
  Allocates a new String that contains characters from a subarray of the character array argument.
  `String(String value)`
  Initializes a newly created String object so that it represents the same sequence of characters as the argument; in other words, the newly created string is a copy of the argument string.
  `String(StringBuffer buffer)`
  Allocates a new string that contains the sequence of characters currently contained in the string buffer argument.
  `String(StringBuilder buffer)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `char`
  `charAt(int index)`
  Returns the character at the specified index.
  `int`
  `compareTo(String anotherString)`
  Compares two strings lexicographically.
  `int`
  `compareToIgnoreCase(String anotherString)`
  `String`
  `concat(String str)`
  Concatenates the specified string to the end of this string.
  `boolean`
  `contains(CharSequence seq)`
  Checks if string contains the given char sequence.
  `boolean`
  `contentEquals(CharSequence cs)`
  `boolean`
  `contentEquals(StringBuffer sb)`
  `static String`
  `copyValueOf(char[] data)`
  `static String`
  `copyValueOf(char[] data, int offset, int count)`
  `boolean`
  `endsWith(String suffix)`
  Tests if this string ends with the specified suffix.
  `boolean`
  `equals(java.lang.Object anObject)`
  Compares this string to the specified object.
  `boolean`
  `equalsIgnoreCase(String anotherString)`
  Compares this String to another String, ignoring case considerations.
  `static String`
  `format(String format, java.lang.Object... args)`
  `byte[]`
  `getBytes()`
  Convert this String into bytes according to the platform's default character encoding, storing the result into a new byte array.
  `byte[]`
  `getBytes(String enc)`
  Convert this String into bytes according to the specified character encoding, storing the result into a new byte array.
  `byte[]`
  `getBytes(java.nio.charset.Charset charset)`
  Convert this String into bytes according to the specified character encoding, storing the result into a new byte array.
  `void`
  `getChars(int srcBegin, int srcEnd, char[] dst, int dstBegin)`
  Copies characters from this string into the destination character array.
  `int`
  `hashCode()`
  Returns a hashcode for this string.
  `int`
  `indexOf(int ch)`
  Returns the index within this string of the first occurrence of the specified character.
  `int`
  `indexOf(int ch, int fromIndex)`
  Returns the index within this string of the first occurrence of the specified character, starting the search at the specified index.
  `int`
  `indexOf(String str)`
  Returns the index within this string of the first occurrence of the specified substring.
  `int`
  `indexOf(String str, int fromIndex)`
  Returns the index within this string of the first occurrence of the specified substring, starting at the specified index.
  `String`
  `intern()`
  Returns a canonical representation for the string object.
  `boolean`
  `isEmpty()`
  Checks if string is empty.
  `int`
  `lastIndexOf(int ch)`
  Returns the index within this string of the last occurrence of the specified character.
  `int`
  `lastIndexOf(int ch, int fromIndex)`
  Returns the index within this string of the last occurrence of the specified character, searching backward starting at the specified index.
  `int`
  `lastIndexOf(String string)`
  Searches in this string for the last index of the specified string.
  `int`
  `lastIndexOf(String subString, int start)`
  Searches in this string for the index of the specified string.
  `int`
  `length()`
  Returns the length of this string.
  `boolean`
  `regionMatches(boolean ignoreCase, int toffset, String other, int ooffset, int len)`
  Tests if two string regions are equal.
  `boolean`
  `regionMatches(int thisStart, String string, int start, int length)`
  Compares the specified string to this string and compares the specified range of characters to determine if they are the same.
  `String`
  `replace(char oldChar, char newChar)`
  Returns a new string resulting from replacing all occurrences of oldChar in this string with newChar.
  `String`
  `replace(CharSequence target, CharSequence replacement)`
  Replaces each substring of this string that matches the literal target sequence with the specified literal replacement sequence.
  `boolean`
  `startsWith(String prefix)`
  Tests if this string starts with the specified prefix.
  `boolean`
  `startsWith(String prefix, int toffset)`
  Tests if this string starts with the specified prefix beginning at the specified index.
  `CharSequence`
  `subSequence(int start, int end)`
  Returns a `CharSequence` from the `start` index (inclusive) to the `end` index (exclusive) of this sequence.
  `String`
  `substring(int beginIndex)`
  Returns a new string that is a substring of this string.
  `String`
  `substring(int beginIndex, int endIndex)`
  Returns a new string that is a substring of this string.
  `char[]`
  `toCharArray()`
  Converts this string to a new character array.
  `String`
  `toLowerCase()`
  Converts all of the characters in this String to lower case.
  `String`
  `toString()`
  This object (which is already a string!) is itself returned.
  `String`
  `toUpperCase()`
  Converts all of the characters in this String to upper case.
  `String`
  `toUpperCase(Locale locale)`
  `String`
  `trim()`
  Removes white space from both ends of this string.
  `static String`
  `valueOf(boolean b)`
  Returns the string representation of the boolean argument.
  `static String`
  `valueOf(char c)`
  Returns the string representation of the char argument.
  `static String`
  `valueOf(char[] data, int offset, int count)`
  Returns the string representation of a specific subarray of the char array argument.
  `static String`
  `valueOf(double d)`
  Returns the string representation of the double argument.
  `static String`
  `valueOf(float f)`
  Returns the string representation of the float argument.
  `static String`
  `valueOf(int i)`
  Returns the string representation of the int argument.
  `static String`
  `valueOf(long l)`
  Returns the string representation of the long argument.
  `static String`
  `valueOf(java.lang.Object obj)`
  Returns the string representation of the Object argument.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### CASE_INSENSITIVE_ORDER

    public static final Comparator<String> CASE_INSENSITIVE_ORDER

- ## Constructor Details

  - ### String

    public String()
    Initializes a newly created String object so that it represents an empty character sequence.

  - ### String

    public String(byte[] bytes)
    Construct a new String by converting the specified array of bytes using the platform's default character encoding. The length of the new String is a function of the encoding, and hence may not be equal to the length of the byte array. bytes - The bytes to be converted into characters JDK1.1

  - ### String

    public String(byte[] bytes, int off, int len)
    Construct a new String by converting the specified subarray of bytes using the platform's default character encoding. The length of the new String is a function of the encoding, and hence may not be equal to the length of the subarray. bytes - The bytes to be converted into charactersoff - Index of the first byte to convertlen - Number of bytes to convert JDK1.1

  - ### String

    public String(byte[] bytes, int off, int len, String enc) throws java.io.UnsupportedEncodingException

    Construct a new String by converting the specified subarray of bytes using the specified character encoding. The length of the new String is a function of the encoding, and hence may not be equal to the length of the subarray. bytes - The bytes to be converted into charactersoff - Index of the first byte to convertlen - Number of bytes to convertenc - The name of a character encoding

    - If the named encoding is not supported JDK1.1
    Throws:
      `java.io.UnsupportedEncodingException`

  - ### String

    public String(byte[] bytes, java.nio.charset.Charset charset) throws java.io.UnsupportedEncodingException

    Construct a new String by converting the specified array of bytes using the specified character encoding. The length of the new String is a function of the encoding, and hence may not be equal to the length of the byte array. bytes - The bytes to be converted into charactersenc - The name of a supported character encoding

    - If the named encoding is not supported

    ###### Since

    8.0

    Throws:
      `java.io.UnsupportedEncodingException`

  - ### String

    public String(byte[] bytes, String enc) throws java.io.UnsupportedEncodingException

    Construct a new String by converting the specified array of bytes using the specified character encoding. The length of the new String is a function of the encoding, and hence may not be equal to the length of the byte array. bytes - The bytes to be converted into charactersenc - The name of a supported character encoding

    - If the named encoding is not supported JDK1.1
    Throws:
      `java.io.UnsupportedEncodingException`

  - ### String

    public String(char[] value)

    Allocates a new String so that it represents the sequence of characters currently contained in the character array argument. The contents of the character array are copied; subsequent modification of the character array does not affect the newly created string. value - the initial value of the string.

    - if value is null.

  - ### String

    public String(char[] value, int offset, int count)

    Allocates a new String that contains characters from a subarray of the character array argument. The offset argument is the index of the first character of the subarray and the count argument specifies the length of the subarray. The contents of the subarray are copied; subsequent modification of the character array does not affect the newly created string. value - array that is the source of characters.offset - the initial offset.count - the length.

    - if the offset and count arguments index characters outside the bounds of the value array.
    - if value is null.

  - ### String

    public String(String value)
    Initializes a newly created String object so that it represents the same sequence of characters as the argument; in other words, the newly created string is a copy of the argument string. value - a String.

  - ### String

    public String(StringBuffer buffer)

    Allocates a new string that contains the sequence of characters currently contained in the string buffer argument. The contents of the string buffer are copied; subsequent modification of the string buffer does not affect the newly created string. buffer - a StringBuffer.

    - If buffer is null.

  - ### String

    public String(StringBuilder buffer)

- ## Method Details

  - ### charAt

    public char charAt(int index)
    Returns the character at the specified index. An index ranges from 0 to length() - 1. The first character of the sequence is at index 0, the next at index 1, and so on, as for array indexing.
    Specified by:
      `charAt` in interface `CharSequence`

  - ### compareTo

    public int compareTo(String anotherString)
    Compares two strings lexicographically. The comparison is based on the Unicode value of each character in the strings. The character sequence represented by this String object is compared lexicographically to the character sequence represented by the argument string. The result is a negative integer if this String object lexicographically precedes the argument string. The result is a positive integer if this String object lexicographically follows the argument string. The result is zero if the strings are equal; compareTo returns 0 exactly when the method would return true. This is the definition of lexicographic ordering. If two strings are different, then either they have different characters at some index that is a valid index for both strings, or their lengths are different, or both. If they have different characters at one or more index positions, let k be the smallest such index; then the string whose character at position k has the smaller value, as determined by using the < operator, lexicographically precedes the other string. In this case, compareTo returns the difference of the two character values at position k in the two string -- that is, the value: this.charAt(k)-anotherString.charAt(k) If there is no index position at which they differ, then the shorter string lexicographically precedes the longer string. In this case, compareTo returns the difference of the lengths of the strings -- that is, the value: this.length()-anotherString.length()
    Specified by:
      `compareTo` in interface `Comparable<String>`
    Returns:

      a negative integer if this instance is less than `another`; a positive integer if this instance is greater than `another`; 0 if this instance has the same order as `another`.

      ###### Throws

      - `ClassCastException`: @throws ClassCastException if `another` cannot be converted into something comparable to `this` instance.

  - ### compareToIgnoreCase

    public int compareToIgnoreCase(String anotherString)

  - ### contentEquals

    public boolean contentEquals(CharSequence cs)

  - ### contentEquals

    public boolean contentEquals(StringBuffer sb)

  - ### copyValueOf

    public static String copyValueOf(char[] data)

  - ### copyValueOf

    public static String copyValueOf(char[] data, int offset, int count)

  - ### concat

    public String concat(String str)
    Concatenates the specified string to the end of this string. If the length of the argument string is 0, then this String object is returned. Otherwise, a new String object is created, representing a character sequence that is the concatenation of the character sequence represented by this String object and the character sequence represented by the argument string. Examples: "cares".concat("s") returns "caress" "to".concat("get").concat("her") returns "together"

  - ### endsWith

    public boolean endsWith(String suffix)
    Tests if this string ends with the specified suffix.

  - ### equals

    public boolean equals(java.lang.Object anObject)
    Compares this string to the specified object. The result is true if and only if the argument is not null and is a String object that represents the same sequence of characters as this object.
    Overrides:
      `equals` in class `java.lang.Object`

  - ### equalsIgnoreCase

    public boolean equalsIgnoreCase(String anotherString)
    Compares this String to another String, ignoring case considerations. Two strings are considered equal ignoring case if they are of the same length, and corresponding characters in the two strings are equal ignoring case. Two characters c1 and c2 are considered the same, ignoring case if at least one of the following is true: The two characters are the same (as compared by the == operator). Applying the method Character.toUpperCase(char) to each character produces the same result. Applying the method Character.toLowerCase(char) to each character produces the same result.

  - ### getBytes

    public byte[] getBytes()
    Convert this String into bytes according to the platform's default character encoding, storing the result into a new byte array.

  - ### getBytes

    public byte[] getBytes(String enc) throws java.io.UnsupportedEncodingException
    Convert this String into bytes according to the specified character encoding, storing the result into a new byte array.
    Throws:
      `java.io.UnsupportedEncodingException`

  - ### getBytes

    public byte[] getBytes(java.nio.charset.Charset charset) throws java.io.UnsupportedEncodingException
    Convert this String into bytes according to the specified character encoding, storing the result into a new byte array.
    Throws:
      `java.io.UnsupportedEncodingException`

  - ### getChars

    public void getChars(int srcBegin, int srcEnd, char[] dst, int dstBegin)
    Copies characters from this string into the destination character array. The first character to be copied is at index srcBegin; the last character to be copied is at index srcEnd-1 (thus the total number of characters to be copied is srcEnd-srcBegin). The characters are copied into the subarray of dst starting at index dstBegin and ending at index: dstbegin + (srcEnd-srcBegin) - 1

  - ### hashCode

    public int hashCode()

    Returns a hashcode for this string. The hashcode for a String object is computed as s[0]*31^(n-1) + s[1]*31^(n-2) + ... + s[n-1] using int arithmetic, where s

    invalid reference

        i

    is the

    th character of the string, n is the length of the string, and ^ indicates exponentiation. (The hash value of the empty string is zero.)

    Overrides:
      `hashCode` in class `java.lang.Object`

  - ### indexOf

    public int indexOf(int ch)
    Returns the index within this string of the first occurrence of the specified character. If a character with value ch occurs in the character sequence represented by this String object, then the index of the first such occurrence is returned -- that is, the smallest value such that: this.charAt( ) == ch is true. If no such character occurs in this string, then -1 is returned.

  - ### indexOf

    public int indexOf(int ch, int fromIndex)

    Returns the index within this string of the first occurrence of the specified character, starting the search at the specified index. If a character with value ch occurs in the character sequence represented by this String object at an index no smaller than fromIndex, then the index of the first such occurrence is returned--that is, the smallest value k such that: (this.charAt( ) == ch) && (

    > = fromIndex) is true. If no such character occurs in this string at or after position fromIndex, then -1 is returned. There is no restriction on the value of fromIndex. If it is negative, it has the same effect as if it were zero: this entire string may be searched. If it is greater than the length of this string, it has the same effect as if it were equal to the length of this string: -1 is returned.

  - ### indexOf

    public int indexOf(String str)
    Returns the index within this string of the first occurrence of the specified substring. The integer returned is the smallest value such that: this.startsWith(str, ) is true.

  - ### indexOf

    public int indexOf(String str, int fromIndex)

    Returns the index within this string of the first occurrence of the specified substring, starting at the specified index. The integer returned is the smallest value such that: this.startsWith(str, ) && (

    > = fromIndex) is true. There is no restriction on the value of fromIndex. If it is negative, it has the same effect as if it were zero: this entire string may be searched. If it is greater than the length of this string, it has the same effect as if it were equal to the length of this string: -1 is returned.

  - ### intern

    public String intern()
    Returns a canonical representation for the string object. A pool of strings, initially empty, is maintained privately by the class String. When the intern method is invoked, if the pool already contains a string equal to this String object as determined by the equals(Object) method, then the string from the pool is returned. Otherwise, this String object is added to the pool and a reference to this String object is returned. It follows that for any two strings s and t, s.intern()==t.intern() is true if and only if s.equals(t) is true. All literal strings and string-valued constant expressions are interned. String literals are defined in Section 3.10.5 of the Java Language Specification

  - ### lastIndexOf

    public int lastIndexOf(int ch)
    Returns the index within this string of the last occurrence of the specified character. That is, the index returned is the largest value such that: this.charAt( ) == ch is true. The String is searched backwards starting at the last character.

  - ### lastIndexOf

    public int lastIndexOf(int ch, int fromIndex)
    Returns the index within this string of the last occurrence of the specified character, searching backward starting at the specified index. That is, the index returned is the largest value such that: (this.charAt(k) == ch) && (k <= fromIndex) is true.

  - ### lastIndexOf

    public int lastIndexOf(String string)

    Searches in this string for the last index of the specified string. The search for the string starts at the end and moves towards the beginning of this string.

    ###### Parameters

    - `string`: the string to find.

    ###### Returns

    Returns:

      the index of the first character of the specified string in this string, -1 if the specified string is not a substring.

      ###### Throws

      - `NullPointerException`: if `string` is `null`.

  - ### lastIndexOf

    public int lastIndexOf(String subString, int start)

    Searches in this string for the index of the specified string. The search for the string starts at the specified offset and moves towards the beginning of this string.

    ###### Parameters

    - `subString`: the string to find.

    - `start`: the starting offset.

    ###### Returns

    Returns:

      the index of the first character of the specified string in this string , -1 if the specified string is not a substring.

      ###### Throws

      - `NullPointerException`: if `subString` is `null`.

  - ### length

    public int length()
    Returns the length of this string. The length is equal to the number of 16-bit Unicode characters in the string.
    Specified by:
      `length` in interface `CharSequence`

  - ### regionMatches

    public boolean regionMatches(boolean ignoreCase, int toffset, String other, int ooffset, int len)
    Tests if two string regions are equal. A substring of this String object is compared to a substring of the argument other. The result is true if these substrings represent character sequences that are the same, ignoring case if and only if ignoreCase is true. The substring of this String object to be compared begins at index toffset and has length len. The substring of other to be compared begins at index ooffset and has length len. The result is false if and only if at least one of the following is true: toffset is negative. ooffset is negative. toffset+len is greater than the length of this String object. ooffset+len is greater than the length of the other argument. There is some nonnegative integer k less than len such that: this.charAt(toffset+k) != other.charAt(ooffset+k) ignoreCase is true and there is some nonnegative integer less than len such that: Character.toLowerCase(this.charAt(toffset+k)) != Character.toLowerCase(other.charAt(ooffset+k)) and: Character.toUpperCase(this.charAt(toffset+k)) != Character.toUpperCase(other.charAt(ooffset+k))

  - ### replace

    public String replace(char oldChar, char newChar)
    Returns a new string resulting from replacing all occurrences of oldChar in this string with newChar. If the character oldChar does not occur in the character sequence represented by this String object, then a reference to this String object is returned. Otherwise, a new String object is created that represents a character sequence identical to the character sequence represented by this String object, except that every occurrence of oldChar is replaced by an occurrence of newChar. Examples: "mesquite in your cellar".replace('e', 'o') returns "mosquito in your collar" "the war of baronets".replace('r', 'y') returns "the way of bayonets" "sparring with a purple porpoise".replace('p', 't') returns "starring with a turtle tortoise" "JonL".replace('q', 'x') returns "JonL" (no change)

  - ### replace

    public String replace(CharSequence target, CharSequence replacement)
    Replaces each substring of this string that matches the literal target sequence with the specified literal replacement sequence. The replacement proceeds from the beginning of the string to the end, for example, replacing "aa" with "b" in the string "aaa" will result in "ba" rather than "ab".

  - ### startsWith

    public boolean startsWith(String prefix)
    Tests if this string starts with the specified prefix.

  - ### startsWith

    public boolean startsWith(String prefix, int toffset)
    Tests if this string starts with the specified prefix beginning at the specified index.

  - ### substring

    public String substring(int beginIndex)
    Returns a new string that is a substring of this string. The substring begins with the character at the specified index and extends to the end of this string. Examples: "unhappy".substring(2) returns "happy" "Harbison".substring(3) returns "bison" "emptiness".substring(9) returns "" (an empty string)

  - ### substring

    public String substring(int beginIndex, int endIndex)
    Returns a new string that is a substring of this string. The substring begins at the specified beginIndex and extends to the character at index endIndex - 1. Thus the length of the substring is endIndex-beginIndex. Examples: "hamburger".substring(4, 8) returns "urge" "smiles".substring(1, 5) returns "mile"

  - ### toCharArray

    public char[] toCharArray()
    Converts this string to a new character array.

  - ### toLowerCase

    public String toLowerCase()
    Converts all of the characters in this String to lower case.

  - ### toString

    public String toString()
    This object (which is already a string!) is itself returned.
    Specified by:
      `toString` in interface `CharSequence`
    Overrides:
      `toString` in class `java.lang.Object`

  - ### toUpperCase

    public String toUpperCase()
    Converts all of the characters in this String to upper case.

  - ### toUpperCase

    public String toUpperCase(Locale locale)

  - ### trim

    public String trim()
    Removes white space from both ends of this string. If this String object represents an empty character sequence, or the first and last characters of character sequence represented by this String object both have codes greater than 'u0020' (the space character), then a reference to this String object is returned. Otherwise, if there is no character with a code greater than 'u0020' in the string, then a new String object representing an empty string is created and returned. Otherwise, let k be the index of the first character in the string whose code is greater than 'u0020', and let m be the index of the last character in the string whose code is greater than 'u0020'. A new String object is created, representing the substring of this string that begins with the character at index k and ends with the character at index m-that is, the result of this.substring(k,m+1). This method may be used to trim whitespace from the beginning and end of a string; in fact, it trims all ASCII control characters as well.

  - ### valueOf

    public static String valueOf(boolean b)
    Returns the string representation of the boolean argument.

  - ### valueOf

    public static String valueOf(char c)
    Returns the string representation of the char argument.

  - ### valueOf

    public static String valueOf(char[] data, int offset, int count)
    Returns the string representation of a specific subarray of the char array argument. The offset argument is the index of the first character of the subarray. The count argument specifies the length of the subarray. The contents of the subarray are copied; subsequent modification of the character array does not affect the newly created string.

  - ### valueOf

    public static String valueOf(double d)
    Returns the string representation of the double argument. The representation is exactly the one returned by the Double.toString method of one argument.

  - ### valueOf

    public static String valueOf(float f)
    Returns the string representation of the float argument. The representation is exactly the one returned by the Float.toString method of one argument.

  - ### valueOf

    public static String valueOf(int i)
    Returns the string representation of the int argument. The representation is exactly the one returned by the Integer.toString method of one argument.

  - ### valueOf

    public static String valueOf(long l)
    Returns the string representation of the long argument. The representation is exactly the one returned by the Long.toString method of one argument.

  - ### valueOf

    public static String valueOf(java.lang.Object obj)
    Returns the string representation of the Object argument.

  - ### subSequence

    public CharSequence subSequence(int start, int end)
    Description copied from interface: `CharSequence`

    Returns a `CharSequence` from the `start` index (inclusive) to the `end` index (exclusive) of this sequence.

    ###### Parameters

    - `start`: @param start the start offset of the sub-sequence. It is inclusive, that is, the index of the first character that is included in the sub-sequence.

    - `end`: @param end the end offset of the sub-sequence. It is exclusive, that is, the index of the first character after those that are included in the sub-sequence

    ###### Returns

    the requested sub-sequence.

    ###### Throws

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `start end`, or if `start` or `end` are greater than the length of this sequence.
    Specified by:
      `subSequence` in interface `CharSequence`

  - ### format

    public static String format(String format, java.lang.Object... args)

  - ### contains

    public boolean contains(CharSequence seq)

    Checks if string contains the given char sequence.

    ###### Parameters

    - `seq`: The charsequence to check

    ###### Returns

    True if seq is contained in string.

  - ### isEmpty

    public boolean isEmpty()

    Checks if string is empty.

    ###### Returns

    True if string is empty

  - ### regionMatches

    public boolean regionMatches(int thisStart, String string, int start, int length)

    Compares the specified string to this string and compares the specified range of characters to determine if they are the same.

    ###### Parameters

    - `thisStart`: the starting offset in this string.

    - `string`: the string to compare.

    - `start`: the starting offset in the specified string.

    - `length`: the number of characters to compare.

    ###### Returns

    Returns:

      `true` if the ranges of characters are equal, `false` otherwise

      ###### Throws

      - `NullPointerException`: if `string` is `null`.